import es
import cfglib

info = es.AddonInfo()
info.name     = 'AutoGunGame'
info.version  = '1.1'
info.author   = 'scaiyth'
info.url      = 'http://addons.eventscripts.com/addons/view/autogungame'
info.description = "Auto loads GunGame on GG maps & more"
info.basename = 'autogungame'

es.ServerVar('AutoGunGame', info.version, 'AutoGunGame: ' + info.description + '\n// by ' + info.author).makepublic()

aggconfig = cfglib.AddonCFG(es.getAddonPath("autogungame") + "/config.cfg")
gg_maps = aggconfig.cvar('agg_maps', 'gg_', 'Mapnames or prefixes which trigger the script to load GunGame')
gungame_version = aggconfig.cvar('agg_load_gungame_ver', 'gungame', 'GunGame version (script name) that will be loaded')
auto_unload_gg = aggconfig.cvar('agg_unload_gg', 1, 'Enable/Disable unloading GunGame on non-GG maps')
auto_disable_ar = aggconfig.cvar('agg_disable_ar', 0, 'Disable mani_anti_rejoin during GunGame')
auto_disable_ar_ggmaps_only = aggconfig.cvar('agg_disable_ar_ggmaps_only', 1, 'Disable mani_anti_rejoin during GunGame (->on GG maps only)\n=> agg_disable_ar must be set to 1 first')


def load():
	aggconfig.execute()
	
def es_map_start(event_var):
	gg_loaded = gg_loaded_check()

	if not gg_loaded and gg_map_check() == 1:
		es.load(gungame_version)
	elif  auto_unload_gg == 1 and gg_loaded and gg_map_check() == 0:
		es.unload(gungame_version)

def round_start(event_var):
	if auto_disable_ar == 1 and gg_loaded_check() == 1:
		if auto_disable_ar_ggmaps_only == 1 and gg_map_check() == 1:
			if es.ServerVar('mani_anti_rejoin') != 0: es.server.queuecmd('mani_anti_rejoin 0')
		elif auto_disable_ar_ggmaps_only == 0:
			if es.ServerVar('mani_anti_rejoin') != 0: es.server.queuecmd('mani_anti_rejoin 0')

def gg_loaded_check():
	if gungame_version != 'gungame':
		if es.exists('script', gungame_version):
			return 1
	else:
		for gungame5 in es.addons.getAddonList():
			gg5string = str(gungame5.__name__)
			if gg5string == gungame_version + '.' + gungame_version:
				return 1
		else:
			return 0

def gg_map_check():
	map = str(es.ServerVar('eventscripts_currentmap')).lower()
	for mapprefix in str(gg_maps).replace(" ", "").split(","):
		if mapprefix != "" and mapprefix.lower() in map:
			return 1
	else:
		return 0